/*
   Dico

   Luc Maranget, projet Moscova, Inria Rocquencourt
 
   Copyright 2005 Institut National de Recherche en Informatique et    
   en Automatique.  All rights reserved.  This file is distributed     
   under the terms of the Q Public License version 1.0.                
*/

class Mset {
  private int [] t ;
  private int card ;
  private Code c ;

  Mset(String s, Code c) {
    card = 0 ;
    this.c = c ;
    int x = c.length() ;
    t = new int [x] ;

    int len = s.length() ;
    for (int i = 0 ; i < len  ; i++) {
      incr(c.code(s.charAt(i))) ;
    }
  }

  void incr(char c) {
    t[c]++ ; card++ ;
  }

  void decr(char c) {
    t[c]-- ; card-- ;
  }
  private boolean do_here(String s, int i) {
    if (i >= s.length())
      return true ;

    char c = s.charAt(i) ;
    if (here(c)) {
      decr(c) ;
      boolean b = do_here(s, i+1) ;
      incr(c) ;
      return b ;
    } else {
      return false ;
    }
  }

  boolean here(String s) {
    return do_here(s, 0) ;
  }

  boolean here(char c) {
    return t[c] > 0 ;
  }

  
  boolean isEmpty() {
    return card == 0 ;
  }

  int length() {
    return card ;
  }

  public String toString() {
    StringBuffer b = new StringBuffer () ;

    b.append("<" + card + ">") ;
    for (char c = 0 ; c < t.length  ; c++) {
      if (t[c] > 0) {
         b.append(" " + this.c.decode(c) + "[" + ((int) c) + "]:" + t[c]) ;
      }
    }
    return b.toString() ;
  }
}
