/*
   Dico

   Luc Maranget, projet Moscova, Inria Rocquencourt
 
   Copyright 2005 Institut National de Recherche en Informatique et    
   en Automatique.  All rights reserved.  This file is distributed     
   under the terms of the Q Public License version 1.0.                
*/

class Options {
  /* Options avec leurs valeurs par dfaut, (voir usage) */
  private final static int dVerbose = 0 ;
  int verbose = dVerbose ;
  private final static  int dMinLen = 1 ;
  int minLen = dMinLen ;
  private final static int dMaxWords = 32 ;
  int maxWords = dMaxWords ;
  /* Arguments */
  String dico, letters ;

  
  void usage(String prog) {
    System.err.println("Usage: java " + prog + " [options]* dico lettres") ;
    System.err.println("Les options sont :") ;
    System.err.println("  -v, affiche des messages sur le fonctionnement, peut tre rpt.") ;
    System.err.println("  -minLen n, taille minimale des mots des anagrammes [dfaut " + dMinLen + "]") ;
    System.err.println("  -maxWords n, nombre maximal de mots des anagrammes [dfaut " + dMaxWords + "]") ;
  }

  int unkownOption(String prog, String [] args, int i) {
    usage(prog) ;
    System.exit(2) ;
    return 0 ; // Not reached
  }

  void parse() {
    int argi=0 ;
    int len = argv.length ;
    while (argi < len && argv[argi].charAt(0) == '-') {
      if (argv[argi].compareTo("-minLen") == 0) {
        minLen = Integer.parseInt(argv[++argi]) ;
      } else if (argv[argi].compareTo("-maxWords") == 0) {
        maxWords = Integer.parseInt(argv[++argi]) ;
      } else if (argv[argi].compareTo("-v") == 0) {
        verbose++ ;
      } else {
        argi = unkownOption(prog, argv, argi) ;
      }
      argi++ ;
    }
    if (argi+2 == argv.length) {
      dico = argv[argi] ;
      letters = argv[argi+1] ;
    } else {
      usage(prog) ;
      System.exit(2) ;
    }
  }

  private String prog ;
  private String [] argv ;

  Options(String prog, String [] argv) {
    this.prog = prog ;
    this.argv = argv ;
  }
}
