final class Tst {
  char val ;
  short count ;
  Tst g, c, d;

  private Tst (char val) {
    this.val = val ;
  }

  private Tst (char val, short count, Tst g, Tst c, Tst d ) {
    this.val = val ;
    this.count = count ;
    this.g = g ;
    this.c = c ;
    this.d = d ;
  }

  /*
  private static int levelCount=0 ;
  private static Tst [] level = new Tst [Mset.NCHARS] ;

  private static void balanceLevel(Tst t) {
    if (t == null) return ;

    balanceLevel(t.g) ;
    t.c = balance(t.c) ;
    level[levelCount++] = t ;
    balanceLevel(t.d) ;
  }

  private static Tst reconstruct(int start, int end) {
    if (end <= start)
      return null ;
    int mid = start + (end-start)/2 ;
    Tst newG = reconstruct(start, mid) ;
    Tst newD = reconstruct(mid+1, end) ;
    Tst t = level[mid] ;
    level[mid] = null ; // Free root
    return new Tst(t.val, t.count, newG, t.c, newD) ;
  }

  static Tst balance (Tst t) {
    if (t == null) return null ;
    int start = levelCount ;
    balanceLevel(t) ;
    int end = levelCount ;
    Tst r =  reconstruct(start, end) ;
    levelCount = start ;
    return r ;
  }
  */

  private void insert_final() {
    count++ ;
  }

  private void do_insert(String s, int i, int len) {
    char x = s.charAt(i) ;
    if (x < val) {
      g = insert(g, s, i, len) ;
    } else if (x > val) {
      d = insert(d, s, i, len) ;
    } else {
      if (i+1 >= len) {
        insert_final() ;
      } else {
        c = insert(c, s, i+1, len) ;
      }
    }
  }

  static Tst insert(Tst t, String s, int i, int len) {
    if (t == null) {
      t = new Tst(s.charAt(i)) ;
    }
    t.do_insert(s, i, len) ;
    return t ;
  }

  static Tst remove(Tst t, String s, int i) {
    if (t == null || i >= s.length())
      return t;
    char c = s.charAt(i) ;
    if (c < t.val)
      return build(t.val, t.count, remove(t.g, s, i), t.c, t.d) ;
    else if (c > t.val)
      return build (t.val, t.count, t.g, t.c, remove(t.d, s, i)) ;
    else if (i+1 >= s.length()) {
      if (t.count > 0) 
        return build(t.val, (short)0, t.g, t.c, t.d) ;
      else
        return t ;
    } else
      return build(t.val, t.count, t.g, remove(t.c, s, i+1), t.d) ;
  }

  private static Tst putRight(Tst g, Tst d) {
    if (g == null)
      return d ;
    else
      return new Tst(g.val, g.count, g.g, g.c, putRight(g.d, d)) ;
  }

  private static Tst build (char val, short count, Tst g, Tst c, Tst d) {
    if (count > 0 || c != null)
      return new Tst(val, count, g, c, d) ;
    else if (d == null)
      return g ;
    else 
      return putRight(g, d) ;
  }

  static Tst filter(Tst t, Mset m) {

    if (t == null) return null ;
    Tst tg = filter(t.g, m) ;
    Tst td = filter(t.d, m) ;
    if (m.here(t.val)) {
      m.decr(t.val) ;
      Tst tc = filter(t.c, m) ;
      m.incr(t.val) ;
      return build(t.val, t.count, tg, tc, td) ;
    } else {    
      return build(t.val, (short)0, tg, null, td) ;
    }
  }

  static boolean look(Tst t, String s) {
    int last = s.length()-1 ;
    int i = 0 ;      
    while (t != null) {
      char x = s.charAt(i) ;

      if (x < t.val) {
        t = t.g ;
      } else if (x > t.val) {
        t = t.d ;
      } else {
        if (i == last) {
          return t.count > 0 ;
        }
        t = t.c ;
        i++ ;
      }
    }
    return false ;
  }

  private int do_nodes() {
    int r = 1 ;
    r += nodes(g) ;
    r += nodes(c) ;
    r += nodes(d) ;
    return r ;
  }

  static int nodes(Tst t) {
    if (t == null)
      return 0 ;
    else
      return t.do_nodes() ;
  }

  static int nwords(Tst t) {
    if (t == null) return 0 ;
    int r = t.count > 0 ? 1 : 0 ;
    r += nwords(t.g) ;
    r += nwords(t.c) ;
    r += nwords(t.d) ;
    return r ;
  }

  private static void do_dump(Tst t, StringBuffer b, Code c) {
    if (t == null) return ;

    do_dump(t.g, b, c) ;
    b.append(t.val) ;
    if (t.count > 0) {
      System.err.println(t.count + " " + c.decode(b.toString())) ;
    }
    do_dump(t.c, b, c) ;
    b.setLength(b.length()-1) ;
    do_dump(t.d, b, c) ;
  }

  static void dump(Tst t, Code c) {
    StringBuffer b = new StringBuffer () ;

    do_dump(t, b, c) ;
  }


  private static int do_freqs(Tst t, Freq f) {
    if (t == null)
      return 0 ;
    int r = 0 ;
    r += do_freqs(t.g, f) ;

    int nwords = do_freqs(t.c, f) ;
    f.add(t.val, nwords) ;
    r += nwords ;
    if (t.count > 0) {
      f.incr(t.val) ;
      r++ ;
    }
    r += do_freqs(t.d, f) ;
    return r ;
  }

  static int freqs (Tst t, Code c) {
    Freq f = new Freq(c.length()) ;
    int nwords = do_freqs(t, f) ;
    if (nwords == 0)
      return -1 ;
    else
      return f.min() ;
  }
}
